package de.sayk;

import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.paint.Color;

public class Utils {

	public static void showErrorOptionPane(String text) {
		Alert alert = new Alert(AlertType.ERROR);
		alert.setTitle("sfmMES");
		alert.setHeaderText("ACHTUNG es ist ein Fehler aufgetreten");
		alert.setContentText(text);
		alert.show();
	}

	public static void showInfoOptionPane(String text) {
		Alert alert = new Alert(AlertType.INFORMATION);
		alert.setTitle("sfmMES");
		alert.setHeaderText(MesApp.title + "\nManufacturing Execution System");
		alert.setContentText(text);
		alert.show();
	}

	private static int getBrightness(Color fx) {

		java.awt.Color c = new java.awt.Color((float) fx.getRed(), (float) fx.getGreen(), (float) fx.getBlue(),
				(float) fx.getOpacity());

		return (int) Math.sqrt(
				c.getRed() * c.getRed() * .241 + c.getGreen() * c.getGreen() * .691 + c.getBlue() * c.getBlue() * .068);
	}

	public static Color getForeGroundColorBasedOnBGBrightness(Color color) {
		if (getBrightness(color) < 130)
			return Color.web("FEEFDA");
		else
			return Color.web("167B6D");

	}

	public static java.awt.Color fxToAwt(Color color) {
		return new java.awt.Color((float) color.getRed(), (float) color.getGreen(), (float) color.getBlue(),
				(float) color.getOpacity());
	}

	public static Color awtToFx(java.awt.Color color) {
		return new javafx.scene.paint.Color(color.getRed() / 255.0, color.getGreen() / 255.0, color.getBlue() / 255.0,
				color.getAlpha() / 255.0);
	}
	
	public static java.awt.Color webToAwt(String color) {
		return Utils.fxToAwt(javafx.scene.paint.Color.web(color));
	}

	public static void main(String[] args) {
		System.out.println(getBrightness(Color.AQUA));
		
		System.out.println( webToAwt("#FF0000"));
		System.out.println(fxToAwt(Color.web("#FF0000")));
		
		
	}
}
