package de.sayk.view;

import de.sayk.data.objects.Order;
import javafx.scene.control.Tab;
import javafx.scene.control.TabPane;

public class ActiveOrderView {

	private static TabPane tabPane = new TabPane();

	public static TabPane getView() {

		return tabPane;

	}

	private static ActiveOrderPane getOrderPane(Order o) {

		for (Tab t : tabPane.getTabs()) {
			if (t.getText().equals(o.getPart().getRfid() + "")) {
				return (ActiveOrderPane) t.getContent();
			}
		}
		// keinen passenden tab gefunden
		Tab newTab = new Tab(o.getPart().getRfid() + "", new ActiveOrderPane());
		newTab.setClosable(false);
		tabPane.getTabs().add(newTab);
		return (ActiveOrderPane) newTab.getContent();
	}

	public static void startOrder(Order o) {
		getOrderPane(o).setOrder(o);
	}

	public static void finishOrder(Order o) {
		getOrderPane(o).setOrder(null);
		int i;
		for (i = 0; i < tabPane.getTabs().size(); i++) {
			if (tabPane.getTabs().get(i).getText().equals(o.getPart().getRfid() + "")) {
				break;
			}
		}
		if (tabPane.getTabs().size() > 0) {
			tabPane.getTabs().remove(i);
		}
	}

	public static void startProcess(Order o) {
		getOrderPane(o).startProcess();
	}

	public static void endProcess(Order o) {
		getOrderPane(o).endProcess();
	}

	public static void setOrder(Order o) {
		getOrderPane(o).setOrder(o);
	}


}
