package de.sayk.view;

import java.io.Serializable;
import java.rmi.RemoteException;
import java.text.SimpleDateFormat;
import java.util.Date;

import de.sayk.ClientListener;
import de.sayk.MesApp;
import de.sayk.PartListener;
import de.sayk.data.ObjectWorld;
import de.sayk.data.objects.Machine;
import de.sayk.data.objects.Part;
import javafx.application.Platform;
import javafx.beans.property.SimpleStringProperty;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Label;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.scene.input.MouseButton;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.HBox;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;

public class ClientView {

	private static TableView table = new TableView();
	// private static ObservableList<ActiveClient> data =
	// FXCollections.observableArrayList(
	// new ActiveClient("1", "Lager", "192.168.1.1", "100.2.3/1.2.3"),
	// new ActiveClient("2", "Wenden", "192.168.100.23", "200.2.0/1.2.3"),
	// new ActiveClient("3", "Drucken", "192.168.12.123", "300.3.0/1.20.34"));
	private static ObservableList<ActiveClient> data = FXCollections.observableArrayList();
	private static ObservableList<ActiveClient> histData = FXCollections.observableArrayList();
	final HBox hb = new HBox();

	static class ClientUpdateListener implements ClientListener, Serializable{

		private static final long serialVersionUID = 3843617088709212772L;

		@Override
		public void newClientRequest(int mid, String name, String ip, String request) throws RemoteException {
			Platform.runLater(new Runnable() {
				
				@Override
				public void run() {
					newData(mid, name, ip, request);
				}
			});
		}

	}
	
	
	private static void newData(int mid, String name, String ip, String request) {

		ActiveClient aac = null; // actual active client
		for (ActiveClient ac : data) {
			if (ac.getId().equals(mid + "") && ac.getIp().equals(ip)) {
				aac = ac;
			}
		}

		if (aac == null) { // dann bau einen Neuen
			aac = new ActiveClient(mid + "", name, ip, request);
			data.add(aac);
		}

		aac.setLastRequest(request);
		table.refresh();

		// add to history
		histData.add(aac.clone());

	}

	public static TableView getView() {

		
		
		
		table.setEditable(true);

		TableColumn idCol = new TableColumn("id");
		idCol.setMaxWidth(20);
		idCol.setCellValueFactory(new PropertyValueFactory<ActiveClient, String>("id"));
		TableColumn nameCol = new TableColumn("name");
		nameCol.setCellValueFactory(new PropertyValueFactory<ActiveClient, String>("name"));
		TableColumn ipCol = new TableColumn("ip");
		ipCol.setMinWidth(100);
		ipCol.setCellValueFactory(new PropertyValueFactory<ActiveClient, String>("ip"));
		TableColumn lastRequestCol = new TableColumn("last request");
		lastRequestCol.setCellValueFactory(new PropertyValueFactory<ActiveClient, String>("lastRequest"));
		TableColumn lastRequestTimeCol = new TableColumn("last time");
		lastRequestTimeCol.setCellValueFactory(new PropertyValueFactory<ActiveClient, String>("lastRequestTime"));

		table.setItems(data);

		table.getColumns().addAll(idCol, nameCol, ipCol, lastRequestCol, lastRequestTimeCol);

		table.setOnMouseClicked(new EventHandler<MouseEvent>() {
			@Override
			public void handle(MouseEvent mouseEvent) {
				if (mouseEvent.getButton().equals(MouseButton.PRIMARY)) {
					if (mouseEvent.getClickCount() == 2) {
						System.out.println("double  ...");

						TableView logTable = new TableView();
						TableColumn idCol = new TableColumn("id");
						idCol.setMaxWidth(20);
						idCol.setCellValueFactory(new PropertyValueFactory<ActiveClient, String>("id"));
						TableColumn nameCol = new TableColumn("name");
						nameCol.setCellValueFactory(new PropertyValueFactory<ActiveClient, String>("name"));
						TableColumn ipCol = new TableColumn("ip");
						ipCol.setMinWidth(100);
						ipCol.setCellValueFactory(new PropertyValueFactory<ActiveClient, String>("ip"));
						TableColumn lastRequestCol = new TableColumn("last request");
						lastRequestCol
								.setCellValueFactory(new PropertyValueFactory<ActiveClient, String>("lastRequest"));
						TableColumn lastRequestTimeCol = new TableColumn("last time");
						lastRequestTimeCol
								.setCellValueFactory(new PropertyValueFactory<ActiveClient, String>("lastRequestTime"));

						logTable.setItems(histData);

						logTable.getColumns().addAll(idCol, nameCol, ipCol, lastRequestCol, lastRequestTimeCol);

						StackPane secondaryLayout = new StackPane();
						secondaryLayout.getChildren().add(logTable);

						Scene secondScene = new Scene(secondaryLayout, 400, 600);

						// New window (Stage)
						Stage newWindow = new Stage();
						newWindow.setTitle("SPS-MES communcation hstory log");
						newWindow.setScene(secondScene);

						// Set position of second window, related to primary window.
						// newWindow.setX(primaryStage.getX() + 200);
						// newWindow.setY(primaryStage.getY() + 100);

						newWindow.show();
					}
				}
			}
		});

		try {
			MesApp.ms.addClientListener(new ClientUpdateListener());
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return table;

	}

	public static class ActiveClient {

		private SimpleStringProperty id;
		private SimpleStringProperty name;
		private SimpleStringProperty ip;
		private SimpleStringProperty lastRequest;
		private SimpleStringProperty lastRequestTime;

		private ActiveClient(String id, String name, String ip, String lastRequest) {
			this.id = new SimpleStringProperty(id);
			this.name = new SimpleStringProperty(name);
			this.ip = new SimpleStringProperty(ip);
			this.lastRequest = new SimpleStringProperty(lastRequest);
			this.lastRequestTime = new SimpleStringProperty();
			this.setLastRequest(lastRequest);
		}

		public String getId() {
			return id.get();
		}

		public String getName() {
			return name.get();
		}

		public String getIp() {
			return ip.get();
		}

		public String getLastRequest() {
			return lastRequest.get();
		}

		public String getLastRequestTime() {
			return lastRequestTime.get();
		}

		public void setId(String id) {
			this.id.set(id);
		}

		public void setName(String name) {
			this.name.set(name);
		}

		public void setIp(String ip) {
			this.ip.set(ip);
		}

		public void setLastRequest(String lastRequest) {

			SimpleDateFormat sdfr = new SimpleDateFormat("HH:mm:ss");
			try {
				this.lastRequestTime.set(sdfr.format(new Date()));
			} catch (Exception ex) {
			}

			this.lastRequest.set(lastRequest);
		}

		public ActiveClient clone() {

			ActiveClient cl = new ActiveClient(id.get(), name.get(), ip.get(), lastRequest.get());

			return cl;
		}

	}
}